
#include "12864_seri.h"



/*******************************************
:Delay_1ms
   :ʱԼ1msʱ
   :
ֵ:
********************************************/
void Delay_1ms(void)
{
  uchar i;
    
  for(i = 150;i > 0;i--);
} 

/*******************************************
:Delay_Nms
   :ʱԼN1msʱ
   :n--ʱ
ֵ:
********************************************/
void Delay_Nms(uint n)
{
  uint i;
    
  for(i = n;i > 0;i--)    Delay_1ms();
}

/*******************************************
:Write_1byte
   :LCDд1byte
   :RW--дƣRS--
        data--
        RW0Ϊд1Ϊ
        RS0Ϊ1Ϊ
ֵ:
********************************************/
void Write_1byte(uint RW,uint RS,uchar data)
{
  uchar H_data,L_data,ID = 0xf8;
  
  if(RW == 1) ID = ID + 0x04;
  if(RS == 1) ID = ID + 0x02;
  
  H_data = data;
  H_data &= 0xf0;
  
  L_data = data;
  L_data &= 0x0f;
  L_data <<= 4;
  
  Write_8bits(ID);
  Delay_1ms();
  Write_8bits(H_data);
  Delay_1ms();
  Write_8bits(L_data);
  Delay_1ms();
}

/*******************************************
:Write_8bits
   :LCDд8bits
   :bit--
ֵ:
********************************************/
void Write_8bits(uchar bit)
{
  uint i;
  
  for(i=0;i<8;i++)
  {
    if(bit & 0x80) SID_H;
    else SID_L;
    SCLK_H;
    bit <<= 1;
    SCLK_L;
  }
}

/*******************************************
:Write_Cmd
   :LCDд
   :cmd--
ֵ:
********************************************/
void Write_Cmd(uchar cmd)
{
  CS_L;
  _NOP();
  CS_H;
  
  Write_1byte(0,0,cmd);
  Delay_1ms();
  
  CS_L;
}

/*******************************************
:Write_Dat
   :LCDдʾ
   :dat--ʾ
ֵ:
********************************************/
void Write_Dat(uchar dat)
{
  CS_L;
  _NOP();
  CS_H;
  
  Write_1byte(0,1,dat);
  Delay_1ms();
  
  CS_L;
}

/*******************************************
:Lcd_Init
   :Һʼ
   :
ֵ:
********************************************/
void Lcd_Init(void)
{
  Delay_Nms(500);
  Write_Cmd(0x30);            //ָ
  Delay_1ms();
  Write_Cmd(0x02);            //ַλ
  Delay_1ms();
  Write_Cmd(0x0c);            //ʾ򿪣αر
  Delay_1ms();
  Write_Cmd(0x01);            //ʾ
  Delay_1ms();
  Write_Cmd(0x06);            //α
  Delay_1ms();
  Delay_1ms();
}


/*******************************************
:Locat_XY
   :Һʾַ
   :x--еַy--еַ
        0<=x<=3,0<=y<=7
ֵ:
********************************************/
void Locat_XY(uint x,uint y)
{
  switch(y)
  {
   case 0:
     Write_Cmd(0x80+x);break;
   case 1:
     Write_Cmd(0x90+x);break;
   case 2:
     Write_Cmd(0x88+x);break;
   case 3:
     Write_Cmd(0x98+x);break;
   default:break;
  }
}

/*******************************************
:Write_Datas
   :дַ
   :*s--ַ
ֵ:
********************************************/
void Write_Datas(uchar *s)
{
  char i;
  while(*s>0)
  {
    Write_Dat(*s);
    s++;
    for(i=10;i>0;i--);
  }
}

/*******************************************
:Write_Str
   :ָʼдַ
   :x--еַy--еַ*s--ַ
        0<=x<=3,0<=y<=7
ֵ:
********************************************/
void Write_Str(uint x,uint y,uchar *s)
{
 Locat_XY(x,y);
 Write_Datas(s);
 Delay_Nms(2);
 
}

/*******************************************
:Disp-Img
   :ʾͼƬ
   :*img--ͼƬ
ֵ:
********************************************/
void Disp_Img(uchar *img)
{
    uint j=0;
    uchar x,y;
    for(y=0;y<32;y++)                     //ֱ32λ
    for(x=0;x<8;x++)                      //ˮƽ16
    {
       Write_Cmd(0x36);                   //չָ
       Write_Cmd(y+0x80);                 //д봹ֱ
       Write_Cmd(x+0x80);                 //дˮƽ
       Write_Cmd(0x30);                   //ָ
       Write_Dat(img[j++]);
       Write_Dat(img[j++]);
    }
    for(y=0;y<32;y++)                     //ֱ32λ
    for(x=0;x<8;x++)                      //ˮƽ16
    {
       Write_Cmd(0x36);                   //չָ
       Write_Cmd(y+0x80);                 //д봹ֱ
       Write_Cmd(x+0x88);                 //дˮƽ
       Write_Cmd(0x30);                   //ָ
       Write_Dat(img[j++]);
       Write_Dat(img[j++]);
    }
}


