#include "msp430g2452.h"

typedef unsigned char uchar;
typedef unsigned int  uint;

#define LCD_PORT_DIR P2DIR
#define LCD_PORT_OUT P2OUT

#define CS   BIT0
#define SID  BIT1
#define SCLK BIT2

#define LCD_OUT LCD_PORT_DIR |= CS + SID + SCLK

#define CS_H LCD_PORT_OUT |= CS
#define CS_L LCD_PORT_OUT &= ~CS

#define SID_H LCD_PORT_OUT |= SID
#define SID_L LCD_PORT_OUT &= ~SID

#define SCLK_H LCD_PORT_OUT |= SCLK
#define SCLK_L LCD_PORT_OUT &= ~SCLK

#define BASIC_SET 0x30; //ָ
#define EXTEND_SET 0x34; //չָ
#define DRAM_ON 0x36; //ͼ
#define DRAM_OFF 0x34; //ͼ

void Delay_1ms(void);
void Delay_Nms(uint n);
void Write_1byte(uint RW,uint RS,uchar data);
void Write_8bits(uchar bit);
void Write_Cmd(uchar cmd);
void Write_Dat(uchar dat);
void Write_Datas(uchar *s);
void Disp_Img(uchar *img);
void Lcd_Init(void);
void Locat_XY(uint x,uint y);
void Write_Str(uint x,uint y,uchar *s);
