

#include "msp430g2452.h"
//#include "clock.h"
#include "12864_seri.h"

#define RESET_L P1OUT &= ~BIT7
#define RESET_H P1OUT |= BIT7
#define ADD_L P2OUT &= ~BIT3
#define ADD_H P2OUT |= BIT3
#define SCS_L  P2OUT &= ~BIT4
#define SCS_H  P2OUT |= BIT4
#define CLK_L P2OUT &= ~BIT5
#define CLK_H P2OUT |= BIT5

unsigned char LCD[6]={'0','0','0','0','0','0'};
unsigned char alarm[4];
unsigned char data_down_chr[3];
unsigned char data_up_chr[3];
unsigned char data_down=10,data_up=35;
unsigned char directory=0;
unsigned long temp=25;
unsigned int tempInt;
unsigned int avg[10]={0,0,0,0,0,0,0,0,0,0}; 

void delayus(unsigned int n)       //΢ʱ
{
	volatile unsigned int i;
	for(i=0; i<n; i++);
}

void delayms(unsigned int m)      //ʱ
{
	volatile unsigned int i,j;
    for(i=0 ; i<m ; i++)
	{
		for(j=0; j<100; j++);
	}
}


void adressing(char num)         //Ѱַ
{
	volatile char i;
	RESET_L;
	delayms(3);
	RESET_H;
	delayms(17);
	SCS_L;
        delayms(2);		               //źڵ͵ƽ5ms
	for(i=0;i<8;i++)
	{
		CLK_L;
		if(num & BIT0)
		{
			ADD_H;
		}
		else
		{
			ADD_L;
		}
		num >>= 1;
		delayus(50);
		CLK_H;
		delayus(50);
	}
	SCS_H;
}

void soundnum(unsigned char *num)     //¶Ⱥ
{
	if(!(num[0] || num[1]))       //Ϊ
	{
		adressing(num[1]);
		delayms(400);
		if(num[3] != 0)            //С
		{
			adressing(11);
			delayms(400);
			adressing(num[2]);
			delayms(400);
			adressing(num[3]);
			delayms(400);
		}
		else
		{
			if(num[2] != 0)
			{
				adressing(11);
				delayms(400);
				adressing(num[2]);
				delayms(400);
			}
		}
	}
	else
	{
		if(num[0] != 0)              //ʮλ
		{
		   adressing(num[0]);
		   delayms(400);
		   adressing(10);
		   delayms(400);
		}

		if(num[1] != 0)             //λ
		{
		   adressing(num[1]);
		   delayms(400);
		}

		if(num[3] != 0)            //С
		{
			adressing(11);
			delayms(400);
			adressing(num[2]);
			delayms(400);
			adressing(num[3]);
			delayms(400);
		}

		else
		{
			if(num[2] != 0)
			{
				adressing(11);
				delayms(400);
				adressing(num[2]);
				delayms(400);
			}
		}
	}
    adressing(12);
    delayms(700);
}

void warning(unsigned int num)       //¶ȱ
{
	if(num < (unsigned int)data_down)              //¶ޱ
	{
		adressing(14);
            //    delayms(4000);
	}

	if(num >= (unsigned int)data_up)                //¶ޱ
	{
		adressing(13);
             //   delayms(4000);
	}
}

void Greetings(void)
{
  adressing(0x0f);
  delayms(3000);
}




void Volt_To_LCD(unsigned int ADC_data)
{
        unsigned  char i;     
        unsigned long int num_all;
        for(i=0;i<9;i++)
        {
          avg[i]=avg[i+1];
        }
        avg[9]=(int)(ADC_data*11.196);//11.196,10.722,9.775; //ת¶
        num_all=0;
        for(i=0;i<10;i++)
        {
          num_all += avg[i];
        }
        temp =num_all/10;
        if(temp>=9999)
        {temp=9999;}
  	//temp=ADC_data*9.775; //ת¶
	LCD[0]=temp%10000/1000+'0'; //ʮλ
	LCD[1]=temp%1000/100+'0'; //λ
	LCD[2]='.'; //С
	LCD[3]=temp%100/10+'0'; //ʮλ
	LCD[4]=temp%10+'0'; //ٷλ
	LCD[5]='\0'; //ַ־  
        
        alarm[0]=temp%10000/1000;
        alarm[1]=temp%1000/100;
        alarm[2]=temp%100/10;
        alarm[3]=temp%10;
        
        tempInt=temp%10000/100;
}

void Data_To_chr(unsigned char data1,unsigned char data2)
{

  data_down_chr[0]=data1%100/10+'0';
  data_down_chr[1]=data1%10+'0';
  data_down_chr[2]='\0';
  
  data_up_chr[0]=data2%100/10+'0';
  data_up_chr[1]=data2%10+'0';
  data_up_chr[2]='\0';
  
   Write_Str(3,2,data_down_chr);
   Write_Str(5,2,data_up_chr);
}

void GPIO()
{
  P1DIR |= BIT7;
  P1OUT |= BIT7;
  P2DIR |= BIT3 + BIT4 + BIT5;
  P2OUT |= BIT3 + BIT4 + BIT5;
        
  P1DIR &= ~BIT3;
  P1DIR &= ~BIT4;
  P1DIR &= ~BIT5;
  
  P1OUT |= BIT3;
  P1OUT |= BIT4;
  P1OUT |= BIT5;
  
  P1REN |= BIT3;
  P1REN |= BIT4;
  P1REN |= BIT5;
  
  P1IE |= BIT3;
  P1IE |= BIT4;
  P1IE |= BIT5;
  
  P1IES |= BIT3;
  P1IES |= BIT4;
  P1IES |= BIT5;
  
  P1IFG &= ~BIT3;
  P1IFG &= ~BIT4;  
  P1IFG &= ~BIT5;
  
  P1DIR = BIT0;
  P1OUT &= ~BIT0;
}

void ADC10_Init()
{
	ADC10CTL0=ADC10SHT_2+ADC10ON;//;+ADC10IE;
	ADC10CTL1 = INCH_1;
	ADC10AE0 |= 0x02;
	P1DIR |=0x01;
}

void main( void )
{
  WDTCTL = WDTPW + WDTHOLD;                 //Stop watchdog timer
  unsigned char cnt=0;
  
  
  LCD_OUT;                                  //LCD˿ڷ
  Lcd_Init();                               //LCDʼ
  ADC10_Init();
  GPIO();
  _BIS_SR(GIE);
  
  Write_Str(1,0,"¶ȼϵͳ");
  Write_Str(0,1,"¶: ----- ");
  Write_Str(0,2,": 01--80");
  Write_Str(0,3,"    ");
  Greetings();
  while(1)
  	{
  		ADC10CTL0 |=ENC + ADC10SC;
  		//LPM0;
                Volt_To_LCD(ADC10MEM);                               
  		Write_Str(3,1,LCD); 
                
                 Data_To_chr(data_down,data_up); 
                 
                /*----------
                Ƿߵ±
                ************/
                if(cnt>30)
                {
                warning(tempInt);
                cnt=0;
                }
                else
                {
                  cnt++;
                }
                
                  
                switch (directory)
                {
                case 0:
                  {
                    Write_Str(1,0,"¶ȼϵͳ");
                    Write_Str(0,1,"¶: ");
                    Write_Str(6,1,"");
                    Write_Str(0,2,": ");
                    Write_Str(6,2,"");
                    Write_Str(0,3,"    ");
                  }
                  break;
                case 1:
                  {
                    Write_Str(1,0,"¶ȼϵͳ");
                    Write_Str(0,1,"¶: ");
                    Write_Str(6,1,"");
                    Write_Str(0,2,": ");
                    Write_Str(6,2,"");
                    Write_Str(0,3," >ϵ >µ");
                  }
                  break;
                case 2:
                  {
                    Write_Str(1,0,"¶ȼϵͳ");
                    Write_Str(0,1,"¶: ");
                    Write_Str(6,1,"");
                    Write_Str(0,2,": ");
                    Write_Str(6,2,"");
                    Write_Str(0,3," >ϵ >µ");
                  }
                  break;
                }

  	}
}

/*
#pragma vector=ADC10_VECTOR
__interrupt void ADC10_ISR(void)
{
	LPM0_EXIT;
}*/

#pragma vector = PORT1_VECTOR
__interrupt void Port_1()
{
  P1OUT |= BIT0;
 // Delay_Nms(100);
  switch (directory)
  {
  case 0:
    {
      if(!(P1IN&BIT3))
       {
         adressing(0x13);
          directory=1;//Ŀ¼1          
        }
       else if(!(P1IN&BIT4))
       {
         adressing(0x12);
          directory=2;//Ŀ¼2
       }
       else if(!(P1IN&BIT5))
       {
          //
         soundnum(alarm);
        }    
    }
    break;
  case 1:
    {
      if(!(P1IN&BIT3))
       {
         adressing(0x14);
          directory=0;//Ŀ¼
        }
       else if(!(P1IN&BIT4))
       {
         adressing(0x10);
          data_down++;
          if(data_down<=0)
          {
            data_down=0;
          }
          if(data_down>=data_up)
          {
            data_down=data_up-1;
          }
       }
       else if(!(P1IN&BIT5))
       {
          
          if(data_down<=1)
          {
            data_down=1;
          }
          adressing(0x11);
          data_down--;
          if(data_down>=data_up)
          {
            data_down=data_up-1;
          }
        }    
    }
    break;
  case 2:
    {
      if(!(P1IN&BIT3))
       {
         adressing(0x14);
          directory=0;//Ŀ¼
        }
       else if(!(P1IN&BIT4))
       {
          
          if(data_up>=98)
          {
            data_up=98;
          }
          adressing(0x10);
          data_up++;
          if(data_down>=data_up)
          {
            data_up=data_down+1;
          }
       }
       else if(!(P1IN&BIT5))
       {
         adressing(0x11);
          data_up--;
          if(data_up>=100)
          {
            data_up=100;
          }
          if(data_down>=data_up)
          {
            data_up=data_down+1;
          }          
        }    
      }
      break;
  }  
  P1OUT &= ~BIT0;
  P1IFG &= ~BIT3;
  P1IFG &= ~BIT4;
  P1IFG &= ~BIT5;
}
